package java.util.function;

import java.util.Objects;

@FunctionalInterface
public interface BiPredicate<T, U>
{
    public abstract boolean test(T p0, U p1);
    
    default public BiPredicate<T, U> and(BiPredicate<? super T, ? super U> obj) {
        Objects.requireNonNull(obj);
        return (o, o2)/* java.lang.Object,java.lang.Object, */ -> this.test(o, o2) && p0.test(o, o2);
    }
    
    default public BiPredicate<T, U> negate() {
        return (o, o2)/* java.lang.Object,java.lang.Object, */ -> !this.test(o, o2);
    }
    
    default public BiPredicate<T, U> or(BiPredicate<? super T, ? super U> obj) {
        Objects.requireNonNull(obj);
        return (o, o2)/* java.lang.Object,java.lang.Object, */ -> this.test(o, o2) || p0.test(o, o2);
    }
}
